#!/var/pycore/bin/python
# -*- coding: utf-8 -*-
'''
package python app
Created on 2019/3/11
@author: CC 
'''
import os
import sys
import shutil
#import commands
import strict_rfc3339
import time
import json

pyapp_base_dir = '/var/user/app/'
pyapp_lib_dir = '/var/user/lib/'
pycore_bin_dir = '/var/pycore/bin/'
fw_info_file = '/tmp/fwinfo.txt'
pyapp_name = None
pyapp_name_bak = None
pyapp_version = None
pyapp_rsa_pri_key = '/etc/dm/rsa_pyapp_private.key'
pyapp_pri_pw = 'mp2rXSXumnQoQ4aFIVJHuM0VGX0jTWIbgp7c3OqC47WdLImWAozxwIfEf2t4CbjE5AyKrOmP0hymS6wPyNGY136muWZ7zHPiBto4YCK8rtIKa4OGMVvm1x3uZ+iy81DxusGU+kYBhPYotaEmFAg8S58ukM4FKEbcJlVw1lqL8+g='

def help():
    print("Usage:")
    print("    pkg_app.py <appname> <app_version>")

    sys.exit(-1)

def get_app_base_dir():
    global pyapp_base_dir
    global pyapp_lib_dir

    if not os.access(fw_info_file, os.F_OK):
        return False

    with open(fw_info_file, "r") as fp:
        fw_info = fp.read().replace("'", "\"")
        model_name = json.loads(fw_info)['model_name']
        model_name = model_name.strip()
        if model_name.find('501L') >= 0 or model_name.find('902') >= 0:
            pyapp_base_dir = '/var/user/app/'
            pyapp_lib_dir = '/var/user/lib/'
        else:
            pyapp_base_dir = '/var/app/'
            pyapp_lib_dir = '/var/app/lib/'
        

def get_app_version():
    global pyapp_version
    global pyapp_name

    pyapp_dir = pyapp_base_dir + pyapp_name
    app_setup_file = pyapp_dir + '/' + 'setup.py' 

    if not os.access(app_setup_file, os.F_OK):
        return False

    with open(app_setup_file, "r", encoding='utf-8') as f:
        for rline in f.readlines():
            if "version" in rline and "sdk_version" not in rline and "=" in rline:
                pyapp_version = rline.split("=", 1)[1][1:-3]
                break
    

def generate_app_info():
    global pyapp_name

    pyapp_dir = pyapp_base_dir + pyapp_name
    app_info_file = pyapp_dir + '/' + pyapp_name + '.info'
    app_setup_file = pyapp_dir + '/' + 'setup.py' 

    if not os.access(app_setup_file, os.F_OK):
        return False

    with open(app_setup_file, "r", encoding='utf-8') as f:
        info = {}
        for rline in f.readlines():
            if "name" in rline and "=" in rline:
                info["name"] = rline.split("=", 1)[1][1:-3]
            if "sdk_version" in rline and "=" in rline:
                info["sdk_version"] = rline.split("=", 1)[1][1:-3]
            elif "version" in rline and "=" in rline:
                info["version"] = rline.split("=", 1)[1][1:-3]
            if "author" in rline and "=" in rline:
                info["author"] = rline.split("=", 1)[1][1:-3]

    with open(app_info_file, "w") as fp:
        json.dump(info, fp)


def pkg_app():
    pyapp_dir = pyapp_base_dir + pyapp_name
    if not os.path.exists(pyapp_dir):
        return False

    cmd = 'rm -f %s/*.tar.gz' % (pyapp_dir)
    os.system(cmd)

    app_info = pyapp_dir + '/' + pyapp_name + '.info'
    if not os.path.exists(app_info):
        print("This APP is invalid!") 
        return False

    pyapp_bak_dir = pyapp_base_dir + pyapp_name_bak

    cmd = 'rm -rf %s;mkdir -p %s' % (pyapp_bak_dir, pyapp_bak_dir)
    os.system(cmd)

    cmd = 'rm -rf %s/build' % (pyapp_dir)
    os.system(cmd)

    cmd = 'cp -rf %s %s/' % (pyapp_dir, pyapp_bak_dir)
    os.system(cmd)

    cmd = 'rm -rf %s/%s/.vscode' % (pyapp_bak_dir, pyapp_name)
    os.system(cmd)

    cmd = 'rm -rf %s/%s/build' % (pyapp_bak_dir, pyapp_name)
    os.system(cmd)

    cmd = 'cp -rf %s %s/' % (pyapp_lib_dir, pyapp_bak_dir)
    os.system(cmd)

    pip_dir=pycore_bin_dir + 'pip2'
    if os.access(pip_dir, os.F_OK):
        cmd = 'find %s/%s/src -name "*.py"|xargs python -m compileall 1>/dev/null' % (pyapp_bak_dir, pyapp_name)
        os.system(cmd)
        cmd = 'find %s/%s/lib -name "*.py"|xargs python -m compileall 1>/dev/null' % (pyapp_bak_dir, pyapp_name)
        os.system(cmd)
    else:
        cmd = 'find %s/%s/src -name "*.py"|xargs python -m compileall -b 1>/dev/null' % (pyapp_bak_dir, pyapp_name)
        os.system(cmd)
        cmd = 'find %s/%s/lib -name "*.py"|xargs python -m compileall -b 1>/dev/null' % (pyapp_bak_dir, pyapp_name)
        os.system(cmd)

    cmd = 'find %s/%s/src -name "*.py" | xargs rm -rf' % (pyapp_bak_dir, pyapp_name)
    os.system(cmd)

    app_lib_dir = pyapp_bak_dir + '/' + pyapp_name + '/lib'
    if os.access(app_lib_dir, os.F_OK):
        cmd = 'find %s/%s/lib -name "*.py" | xargs rm -rf' % (pyapp_bak_dir, pyapp_name)
        os.system(cmd)

    #cmd = 'ln -s %s/%s/src/main.pyc /tmp/%s/bin/%s' % (pyapp_base_dir, pyapp_name, pyapp_name, pyapp_name)
    #os.system(cmd)

    app_bak_info = pyapp_bak_dir + '/' + pyapp_name + '/' + pyapp_name + '.info'
    cmd = 'rm -f %s' % (app_bak_info) 
    os.system(cmd)

    cmd = 'cd %s;tar -czf %s-V%s.tar.gz lib %s' % (pyapp_bak_dir, pyapp_name, pyapp_version, pyapp_name)
    os.system(cmd)

    cmd = 'openssl2 enc -d -aes256 -in %s -out %s/%s.key -pass pass:%s' % (pyapp_rsa_pri_key, pyapp_bak_dir, pyapp_name, pyapp_pri_pw)
    os.system(cmd)

    cmd = 'openssl2 dgst -sign %s/%s.key -sha1 -out %s/%s.sign %s/%s-V%s.tar.gz' % (pyapp_bak_dir, pyapp_name, pyapp_bak_dir, pyapp_name, pyapp_bak_dir, pyapp_name, pyapp_version)
    os.system(cmd)

    cmd = 'cp %s %s;cd %s;tar -czf %s-V%s.tar.gz %s-V%s.tar.gz %s.info %s.sign' % (app_info, pyapp_bak_dir, pyapp_bak_dir, pyapp_name_bak, pyapp_version, pyapp_name, pyapp_version, pyapp_name, pyapp_name)
    os.system(cmd)

    build_app_dir = pyapp_dir + '/build'
    if not os.access(build_app_dir, os.F_OK):
        os.mkdir(build_app_dir)

    cmd = 'mv %s/%s-V%s.tar.gz %s/%s-V%s.tar.gz' %  (pyapp_bak_dir, pyapp_name_bak, pyapp_version, build_app_dir, pyapp_name, pyapp_version)
    os.system(cmd)

    cmd = 'rm -rf %s' %  (pyapp_bak_dir)
    os.system(cmd)


if __name__ == '__main__':
    if len(sys.argv) < 2:
        help()

    pyapp_name = sys.argv[1]
    pyapp_name = pyapp_name.strip()
    pyapp_name = pyapp_name.rstrip('/')
    pyapp_name_bak = pyapp_name + 'bak'
    #pyapp_version = sys.argv[2]

    get_app_base_dir()
    app_dir = pyapp_base_dir + pyapp_name
    if not os.path.exists(app_dir):
        sys.exit(0)

    app_bak_dir = pyapp_base_dir + pyapp_name_bak
    cmd = 'rm -rf %s' %  (app_bak_dir)
    os.system(cmd)

    get_app_version()

    if pyapp_name.strip() == ""  or pyapp_version.strip() == "":
        help()

    generate_app_info()
    pkg_app()

